'use strict';

var debug = require('debug')('geteventstore:ping');
var req = require('request-promise');
var url = require('url');

module.exports = function (config) {
    var buildUrl = function buildUrl() {
        var urlObj = JSON.parse(JSON.stringify(config));
        urlObj.pathname = '/ping';
        return url.format(urlObj);
    };

    return function () {
        var options = {
            uri: buildUrl(),
            method: 'GET',
            timeout: config.timeout
        };
        debug('', 'Options: %j', options);
        return req(options).then(function (response) {
            debug('', 'Response: %j', response);
            return response;
        });
    };
};