'use strict';

var debug = require('debug')('geteventstore:getAllProjectionsInfo');
var req = require('request-promise');
var url = require('url');

module.exports = function (config) {
    var buildUrl = function buildUrl() {
        var urlObj = JSON.parse(JSON.stringify(config));
        urlObj.pathname = '/projections/all-non-transient';
        return url.format(urlObj);
    };

    return function () {
        var options = {
            uri: buildUrl(),
            method: 'GET'
        };

        return req(options).then(function (response) {
            debug('', 'Response: %j', response);
            return JSON.parse(response);
        });
    };
};