'use strict';

var debug = require('debug')('geteventstore:getProjectionInfo');
var Promise = require('bluebird');
var assert = require('assert');
var _ = require('lodash');

var baseErr = 'Get Projection Info - ';

module.exports = function (config) {
    var getAllProjectionsInfo = require('./getAllProjectionsInfo')(config);

    return function (name) {
        return Promise.resolve().then(function () {
            assert(name, baseErr + 'Name not provided');

            return getAllProjectionsInfo().then(function (projectionsInfo) {
                var projectionInfo = _.find(projectionsInfo.projections, function (projection) {
                    return projection.name === name;
                });
                debug('', 'Projection Info: %j', projectionInfo);
                return projectionInfo;
            });
        });
    };
};