'use strict';

var _ = require('lodash');

module.exports = function (events) {
    return _.map(events, function (ev) {
        var event = ev.event;
        var link = ev.link;

        var mappedEvent = {
            data: JSON.parse(event.data.toString()),
            eventStreamId: event.eventStreamId,
            eventNumber: event.eventNumber,
            eventType: event.eventType,
            created: event.created,
            metadata: event.metadata,
            isJson: event.isJson
        };

        if (link) {
            mappedEvent.positionStreamId = link.eventStreamId;
            mappedEvent.positionEventNumber = link.eventNumber;
        }
        return mappedEvent;
    });
};